#version 120

varying vec3 outOrigPos;
varying vec3 outNormal;

uniform sampler3D noiseTex;
//uniform mat4 mvp;
uniform vec4 thrustColor0;
uniform vec4 thrustColor1;
uniform float ticks;

void main()
{
	
	float cosang;
	float edgeAlpha;
	vec4 tc;
	//vec3 Up = normalize(vec3(gl_ModelViewMatrix[0][0],gl_ModelViewMatrix[1][0],gl_ModelViewMatrix[2][0]));
	vec3 Up = normalize(( gl_ModelViewMatrix * vec4(0,0,0,0)).xyz);
	    
	float noiseval;
	
	float heatfactor = thrustColor0.a;

	float heat = 1.03-clamp((outOrigPos.z/2.0) ,0.0002,0.52);
	
	vec2 len = vec2(outOrigPos.y , outOrigPos.x);
	
	heat *= clamp(length(len)/outOrigPos.z*9.2,0.1,1.45);
	
	
	float x= gl_TexCoord[0].x-1 ;
	float y= gl_TexCoord[0].y*1.1+(1)*(5+313*heatfactor);
	float z= ticks;
	//vec4 noise =  texture3D(noiseTex, vec3( x,y,z ) );
	vec4 noise =  texture3D(noiseTex, vec3(gl_TexCoord[0].x,  gl_TexCoord[0].y, 1000 * heatfactor * ticks) );
	noiseval = (noise.x) ;
	
	noiseval = pow(noiseval,0.9+0.04*heatfactor);
	 
	 vec3 a = ( 2*noiseval*pow(heat*heatfactor,2.3)*thrustColor0.rgb*2);
	 vec3 b = 6.15*noiseval*thrustColor1.rgb;
	tc.rgb = ( a + b ); 
	
	edgeAlpha = abs( dot(Up, outNormal));
	edgeAlpha = max(0.34, edgeAlpha-3.1)*3.85;
	
	//this is very specific to the size of the plum
	//this renders the short plum even if viewer is behind it
	if(length(len) < 0.05 && outOrigPos.z < 0.030){
		edgeAlpha += pow(length(len)/0.9,1.3);
	}
	
	tc.a = (edgeAlpha) * pow(heat, 0.1 + 0.89*(2.6-heatfactor));
	if(tc.a <= 0.0001){
		discard;
	}
	
	tc.a -= (1.0 - heatfactor) * 3.37;
	
	gl_FragColor = tc*0.9;
	//gl_FragColor = vec4(outNormal,1);//tc;
}





   